;;;hatchfl.lsp
;;;
;;;Schraffurflchenberechnung
;;;
;;;AutoCAD-Release:	R14
;;;			unter R2000 nur kurz getestet
;;;
;;;Version:		1/8
;;;
;;;Startaufruf:		hatchfl
;;;
;;;zugehrige Dateien:   Schraff.dcl (Dialogfenster)
;;;			legend_1.dwg (als Blockdefinition) -> Vorgabeort c:\ (kann in LISP-gendert werden)
;;;			legend_f.dwg (als Blockdefinition) -> Vorgabeort c:\ (kann in LISP-gendert werden)
;;;
;;;Einschrnkungen:	- Schraffuren, die als Begrenzung SPLINE's haben werden nicht ausgewertet!!!- Dazu fehlt die Programmierung
;;;			- Ellypsen knnen nicht ausgewertet werden!!!
;;;
;;;Programmiert:	Holger Brischke
;;;			brischkh@mre.de
;;;
;;;
;;;
;;;--MAIN----MAIN----MAIN----MAIN----MAIN----MAIN----MAIN----MAIN----MAIN----MAIN----MAIN----MAIN----MAIN----MAIN--
;;;
(defun c:hatchfl (/ ofalt layalt ALISTE ALISTEL elz ELNA ELLI
                    ellayer layerlist z zl fllist fl vgllayer
                    wertlist firmsummlist )
;;;
   ;Systemvariablen
   (if (= (getvar "TILEMODE") 0)
      (command "_tilemode" 1)
   )
   (command "_.zoom" "_al")
   (setq ofalt (getvar "OSMODE"));Objektfangeinstellungen sichern
   (setq layalt (getvar "CLAYER"));aktLayer speichern
   (setvar "OSMODE" 0);Objektfang entfernen
   (setvar "cmdecho" 0)
   ;Zusammenstellen eines gefilterten Auswahlsatzes
   ;Aus allen Zeichnungselementen werden nur die Schraffuren ausgewhlt
   (setq ALISTE (ssget "X"
      '((-4 . "<and")
	 (0 . "HATCH")
;	 (2 . "SOLID");Durch entfernen des ";" werden nur die Solid-Schraffuren ausgewhlt
	 (-4 . "and>")
         )
      )
   )
   (setq ALISTEL ALISTE)
   (setq elz (sslength ALISTE));Anzahl Elemente im Auswahlsatz
   (prin1 elz)
   (prin1 "Objekte gefunden")
   (prin1 "Bitte etwas Gedult...")
;;;
   ;Zusammenstellen der Layer der Schraffuren, damit eine Layerbezogene Auswertung erfolgen kann
   (setq z 0);Zhlvariable fr Element im Auswahlsatz
   (repeat (sslength ALISTE)
      (setq ELNA (ssname aliste z));Elementname
      (setq ELLI (entget ELNA));Elementliste
      (setq ellayer (cdr (assoc 8 ELLI)));Layer des Elementes (der Schraffur)
      (if (= layerlist nil)
         (setq layerlist (list ellayer))
         (if (= nil (member ellayer layerlist));ist Layer scvhon in Liste vorhanden?
            (setq layerlist (append layerlist (list ellayer)));Nein
            ;(princ "\nLayer schon in Liste")
         )
      )
      (setq z (+ z 1))
   )
   ;;;
   ;;;Layerbezogene Auswertung
   ;;;Auf jeden Layer der layerlist werden die Elemente des Auswahlsatzes untersucht
   (setq zl 0)
   (repeat (length layerlist)
      (setq fllist nil)
      (setq vgllayer (nth zl layerlist));Vergleichslayer = Schraffuren auf diesem Layer werden untersucht
      (princ "\n.")
      (princ (strcat "\nSchraffuren auf Layer " vgllayer " werden untersucht!"))
      (setq z 0)
      (repeat (sslength ALISTEL)
         (setq ELNA (ssname ALISTEL z));Elementname
         (setq ELLI (entget ELNA));Elementliste
         (setq ellayer (cdr (assoc 8 ELLI)));Layer des Elementes (der Schraffur)
         (if (= vgllayer ellayer);Wenn Layer der Schraffur = dem derzeit untersuchten Layer ist , dann
            (progn
               (setq wertlist (hatchf ELLI vgllayer));Wertlist = (ergebnis der SUB hatchf)
               (princ "\nWERTLIST")
               (princ wertlist)
               (princ "\n================")
               (if (/= (nth 1 wertlist) nil);Wenn ein Rckgabewert von SUB (HATCHF) existiert , dann
                  (princ (strcat "\nSumme: " (rtos (nth 1 wertlist) 2 2) "m\n."))
               )
            )
         )
         (setq z (+ z 1))
      )
      (if (= firmsummlist nil);Zusammenstellen der Layerbezogenen Ergebnisliste
         (setq firmsummlist wertlist)
         (setq firmsummlist (append firmsummlist wertlist))
      )
      (setq zl (+ zl 1))
   )
   (schreibefltext firmsummlist);Aufruf der Ausgabe-SUB
   (setvar "OSMODE" ofalt);Objektfang-Einstellungen wieder herstellen
   (setvar "CLAYER" layalt);Objektfang-Einstellungen wieder herstellen
);c:hatchfl
;;;
;;;
;;;-SUB--SUB--SUB--SUB--SUB--SUB--SUB--SUB-
;;;
;;;Flchenberechnung der Schraffur
;;;
;;;Aufruf aus:		c:hachfl
;;;Eingangswerte:	Schraffurelementdatenliste
;;;			Layer der Schraffur
;;;
;;;Rckgabewerte:	Liste (Layer,Flche)
;;;
(defun hatchf (elemli aktvgllayer / hatchumglist anzumg liste1 liste1ee liste2 liste2ee li1la li2la ELLI1
                                    ladif elliz ergliste hatchz ww wert92 wert92D2 nkwert pmwiewert93
                                    anzkp wert72 wert42 mltfakt punkteliste wert40 firmsumm )
;;;
   (setq anzumg (cdr (assoc 91 elemli)));Ermittlung der Umgrenzungsanzahlen
   (cond;man mu unterscheiden ob die Schraffur aus einem oder mehreren Umgrenzungspfaden besteht
      ((> anzumg 1);mehrere Umgrenzungen
         ;Krzen der Schraffurelementdaten auf die Umgrenzungspfaddaten - beginnend beim ersten U-Pfad (GC 92)
         (setq liste1 (cdr (member (assoc 92 elemli) elemli)));Liste1 beginnt nach! dem ersten Auftreten des GC 92
         (setq liste1ee (car (member (assoc 92 elemli) elemli))); Liste1ee beinhalten den GC 92 (92 . X)
         ;Bei mehreren Umgrenzungen wird die Schraffurelementliste in einzelne Umgrentzungspfadliste zerlegt
         ;Diese beginnen jeweils mit dem Gruppencode 92
         ;Es werden temp. Listen gebildet. Die Differenz der Anzahl der Listenelemente ist gleich der Anzahl der
         ;GC-Elemente des jeweiligen U-Pfad
         (repeat anzumg
            (setq li1la (length liste1));Anzahl der Listenelemente Liste1
            (setq liste2ee (car (member (assoc 92 liste1) liste1)))
            (setq liste2 (cdr (member (assoc 92 liste1) liste1)));Liste2 beginnt nach! dem X-ten Auftreten des GC 92 (FolgeU-pfad)
            (setq li2la (length liste2));Anzahl der Listenelemente Liste2
            (setq ladif (- li1la li2la));Lngendifferenz = Anzahl der GC des U-Pfades
            (setq elliz 0);Zhler auf null
            (setq ergliste nil);es wird immer eine neue Liste gebaut
            (repeat ladif
               (if (= nil ergliste);wenn erstes Element des Umgrenzungspfades
                  (setq ergliste (list (nth 0 liste1)))
                  (setq ergliste (append ergliste (list (nth elliz liste1))))
               )
               (setq elliz (+ elliz 1))
            )
            (setq ergliste (cons liste1ee ergliste));Das erste Element wird den Pfadangaben wieder hinzugefgt
            ;Umgranzugspfad wird in einer Liste gespeichert
            (if (= hatchumglist nil);bei ersten U-Pfad
               (setq hatchumglist (list ergliste))
               (setq hatchumglist (append hatchumglist (list ergliste)))
            )
            (setq liste1ee liste2ee);Setzen des GC 92 auf folgenden U-Pfad
            (setq liste1 liste2);Setzen der Liste auf folgenden U-Pfad
         )
         (setq hatchz 0)
         (repeat (length hatchumglist);Wiederhole entsprechend der Anzahl der U-Pfade
            (setq ww (nth hatchz hatchumglist));Setzen der U-Pfad-Liste
            ;Wert des GC 92 beinhaltet ob U-Pfad Insel ist oder nicht
            (setq wert92 (cdr (car (member (assoc 92 ww) ww))))
            (if (= (logand wert92 (expt 2 4)) 0);wenn der BIT-Wert 4 NICHT in wert92 enthalten ist,
               (progn;dann ist es eine Umgrenzung
                  (setq pmwie 2)
                  (princ "\nUmgrenzung")
               )
               (progn;sonst ist es eine Insel
                  (setq pmwie 1)
                  (princ "\nINSEL")
               )
            )
            (setq wert93 (cdr (car (member (assoc 93 ww) ww))))
            (setq anzkp (cdr (assoc 93 ww)));Feststellen der Anzahl der Kontrollpunkte
            (setq wert72 (cdr (car (member (assoc 72 ww) ww))));Feststellen des Kantentyps des U-Pfades
            ;die Variable mltfakt bestimmt den Aufbau der Polylinie, aus welcher
            ;dann die Flche berechnet wird, je nach Umgrenzungselementen
            ;          mltfakt = 1 -> Polylinie ohne Kreisbogen - oder einfache Linie
            ;          mltfakt = 2 -> Polylinie mit Kreisbogen
            ;          mltfakt = 3 -> einfache Linie mit Bogenelementen
            ;Aufruf der SUB UMGPLIN ->da werden dann ebntsprechend der Variable mltfakt die Polylinienelementdatenlisten gebaut
            ;Aufruf der SUB MACHPOLYLINE, da wird die Polylinie gezeichnet, und die Flche berechnet
            (cond
               ((= wert72 0);dann sind U-Pfad -Angaben als Polylinie
                  (princ "Polyline")
                  (setq wert42 (cdr (assoc 42 ww)));Feststellen ob Kreisbgen in der Polylinie vorhanden sind
                  (if (= wert42 nil)
                     (progn
                        (princ "----Keine Kreisbogen in PL")
                        (setq mltfakt 1)
                     )
                     (progn
                        (princ "----Kreisbgen in Polylinie")
                        (setq mltfakt 2)
                     )
                  )
                  (setq punkteliste (umgplin ww anzkp mltfakt))
                  (setq fl (machpolyline mltfakt anzkp punkteliste pmwie))
                  (if (= fllist nil)
                     (setq fllist fl)
                     (setq fllist (+ fllist fl))
                  )
               )
               ((= wert72 1);dann sind U-Pfad -Angaben als Linie
                  (princ "Linie")
                  (setq wert42 (cdr (assoc 42 ww)))
                  (if (= wert42 nil)
                     (progn
                        (princ "----Keine Kreisbogen in L")
                        (setq wert40 (cdr (assoc 40 ELLI)))
                        (if (= wert40 nil)
                           (progn
                              (princ "----Keine BGEN in L")
                              (setq mltfakt 1)
                           )
                           (progn
                             (princ "----BGEN in Linie")
                             (setq mltfakt 3)
                          )
                       )
                     )
                     (progn
                        (princ "----Kreisbgen in Linie")
                        (setq mltfakt 2)
                     )
                  )
                  (setq punkteliste (umgplin ww anzkp mltfakt))
                  (if (= mltfakt 3)
                     (setq anzkp (/ (length punkteliste) 2))
                  )
                  (setq fl (machpolyline mltfakt anzkp punkteliste pmwie))
                  (if (= fllist nil)
                     (setq fllist fl)
                     (setq fllist (+ fllist fl))
                  )
               )
               ((= wert72 2);;dann sind U-Pfad -Angaben als Kreis
                  (princ "Kreisbogen")
               )
               ((= wert72 3);;dann sind U-Pfad -Angaben als Ellypse !! von Ellypsen kann keine Flche berechnet werden
                  (princ "elliptischer Bogen")
                  (setq wert93 (cdr (car (member (assoc 93 ww) ww))))
                  (if (/= wert93 1)(alert "\nKEINE Auswertung mglich"))
               )
               ((= wert72 4);dann sind U-Pfad -Angaben als SPLINE !! wird nicht ausgewertet, mu noch programmiert werden
                  (princ "Spline")
                  (alert "Spline- Umgrenzung gefunden! \nWird nicht ausgewertet!")
               )
               ((> wert72 4)
                  (alert "Wat wei ich")
               )
            )
            (setq hatchz (+ hatchz 1))
         )
      )
      ((= anzumg 1);eine Umgrenzung;Berechnung und Ablauf ist gleich fr mehrere U-Pfade
         (setq ELLI1 (cdr (member (assoc 10 elemli) elemli)))
         (setq pmwie 2)
         (setq wert72 (cdr (car (member (assoc 72 ELLI1) ELLI1))))
         (setq anzkp (cdr (assoc 93 ELLI1)));Feststellen der Anzahl der Kontrollpunkte
         (cond
             ((= wert72 0)
               (princ "Polyline")
               (setq wert42 (cdr (assoc 42 ELLI1)))
               (if (= wert42 nil)
                  (progn
                     (princ "----Keine Kreisbogen in PL")
                     (setq mltfakt 1)
                  )
                  (progn
                     (princ "----Kreisbgen in Polylinie")
                     (setq mltfakt 2)
                  )
               )
               (setq punkteliste (umgplin ELLI1 anzkp mltfakt))
               (setq fl (machpolyline mltfakt anzkp punkteliste pmwie))
               (if (= fllist nil)
                  (setq fllist fl)
                  (setq fllist (+ fllist fl))
               )
            )
            ((= wert72 1)
               (princ "Linie")
               (setq wert42 (cdr (assoc 42 elemli)))
               (if (= wert42 nil)
                  (progn
                     (princ "----Keine Kreisbogen in L")
                     (setq mltfakt 1)
                     (setq wert40 (cdr (assoc 40 elemli)))
                     (if (= wert40 nil)
                        (progn
                           (princ "----Keine BGEN in L")
                           (setq mltfakt 1)
                        )
                        (progn
                          (princ "----BGEN in Linie")
                          (setq mltfakt 3)
                       )
                    )
                  )
                  (progn
                     (princ "----Kreisbgen in Linie")
                     (setq mltfakt 2)
                  )
               )
               (setq punkteliste (umgplin ELLI1 anzkp mltfakt))
               (if (= mltfakt 3)
                  (setq anzkp (/ (length punkteliste) 2))
               )
               (setq fl (machpolyline mltfakt anzkp punkteliste pmwie))
               (if (= fllist nil)
                  (setq fllist fl)
                  (setq fllist (+ fllist fl))
               )
            )
            ((= wert72 2)
               (princ "Kreisbogen")
               (setq wert40 (cdr (assoc 40 elemli)))
               (if (= wert40 nil)
                  (progn
                     (princ "----Keine BGEN in L")
                     (setq mltfakt 1)
                  )
                  (progn
                    (princ "----BGEN in Linie")
                    (setq mltfakt 3)
                 )
               )
               (setq punkteliste (umgplin ELLI1 anzkp mltfakt))
               (if (= mltfakt 3)
                  (setq anzkp (/ (length punkteliste) 2))
               )
               (setq fl (machpolyline mltfakt anzkp punkteliste pmwie))
               (if (= fllist nil)
                  (setq fllist fl)
                  (setq fllist (+ fllist fl))
               )
            )
            ((= wert72 3)
               (princ "elliptischer Bogen")
               (setq wert93 (cdr (car (member (assoc 93 ELLI1) ELLI1))))
               (if (/= wert93 1)(alert "\nKEINE Auswertung mglich"))
            )
            ((= wert72 4)
               (princ "Spline")
            )
            ((> wert72 4)
               (alert "Wat wei ich")
            )
         )
      )
   )
   (setq firmsumm (list aktvgllayer fllist))
   firmsumm
);hatchf
;;;
;;;
;;;
;;;-SUB--SUB--SUB--SUB--SUB--SUB--SUB--SUB-
;;;
;;;Erstellung der Polylinienelementdatenliste zur erstellung der Polylinie aus der die Flche berechnet wird
;;;
;;;Aufruf aus:	hatchf
;;;Eingangswerte:	Liste eines! Umgrenzungspfades
;;;			Anzahl der Kontrollpunkte des Umgrenzungspfades
;;;			Art des Umgrenzungspfades
;;;				mltfakt = 1 -> Polylinie ohne Kreisbogen - oder einfache Linie
;;;				mltfakt = 2 -> Polylinie mit Kreisbogen
;;;				mltfakt = 3 -> einfache Linie mit Bogenelementen
;;;
;;;Rckgabewerte:	Kontrollpunktliste, der Polylinie
;;;
(defun umgplin (liste kpanz mltfakt / rdzz pt ptliste ptwink)
   (setq rdzz 0)
   (repeat kpanz;wiederhole entsprechend der Anzahl der Kontrollpunkte des U-Pfades
      (setq pt (assoc 10 liste))
      (setq liste (cdr (member (assoc 10 liste) liste))) 
      (cond
         ((= mltfakt 2);Polylinie mit Kreisbogensegmenten, enthlt GK 42!
            (setq ptwink (assoc 42 liste))
            (setq liste (cdr (member (assoc 42 liste) liste)))
            (if (= rdzz 0)
               (setq ptliste (list pt ptwink))
               (setq ptliste (append ptliste (list pt ptwink)))
            )
         )
         ((= mltfakt 3);Linie mit Bgen
            ;Besteht der U-Pfad aus Linien und Bgen mu eine Umrechnung fr die Polylinieelementdaten erfolgen.
            ;Die Bogenelementdaten mssen in Startpunkt Endpunkt und Ausbuchtung umgerechnet werden.
            ;den Linienelementen mu dann der GC 42 hinzugefgt werden.
            (setq fwert (caar liste))
            (if (= fwert 40)
               (progn
                  (setq wert40 (cdar liste))
                  (setq wert50 (cdadr liste))
                  (setq wert51 (cdar (cddr liste)))
                  (setq wert73 (cdar (cdddr liste)))
                  (setq buchtli (abu (cdr pt) wert40 wert50 wert51 wert73))
                  (setq stpt (car buchtli))
                  (setq enpt (cadr buchtli))
                  (setq bucht (caddr buchtli))
                  (if (= rdzz 0)
                     (setq ptliste (list (cons 10 stpt) (cons 42 bucht) (cons 10 enpt) (cons 42 0.0)))
                     (setq ptliste (append ptliste (list (cons 10 stpt) (cons 42 bucht) (cons 10 enpt) (cons 42 0.0))))
                  )
               )
               (progn
                  (if (= rdzz 0)
                     (setq ptliste (list pt (cons 42 0.0)))
                     (setq ptliste (append ptliste (list pt (cons 42 0.0))))
                  )
               )
            )
         )
         ((= mltfakt 1);Polylinie ohne Kreisbgen oder Linie, brauch keinen GK 42, nur GK 10 bentigt
            (if (= rdzz 0)
               (setq ptliste (list pt))
               (setq ptliste (append ptliste (list pt)))
            )
         )
      )
      (setq rdzz (+ rdzz 1))
   )
   ptliste
);umgplin
;;;
;;;-SUB--SUB--SUB--SUB--SUB--SUB--SUB--SUB-
;;;
;;;Berechnung der Ausbuchtung eines Bogens
;;;
;;;Aufruf aus:	umgplin
;;;
;;;Eingangswerte:	Mittelpunkt des Bogens
;;;			Radius des Bogens
;;;			Startwinkel des Bogens
;;;			Endwinkel des Bogens
;;;
;;;			Zeichenrichtung des Bogens
;;;Rckgabewerte:	Liste(Startpunt Endpunkt Ausbuchtung)
;;;
;;;bergabe: Mittelpunkt Radius Startwinkel Endwinkel Richtung
;;;
(defun abu (mp ra sw ew w73 / spt ept ufak sempt D hlpdist hlpwink H abung buli)
   ;je nach Richtung des Bogens
   (if (= w73 0)
      (progn
         (setq spt (polar mp (- pi (- sw pi)) ra));Startpunkt des Bogens
         (setq ept (polar mp (- (* 2 pi) ew) ra));Endpunkt des Bogens
         (setq ufak 1);Setzen eines Faktors zur Vorzeichenumrechnung fr Ausbuchtungswert
      )
      (progn
         (setq spt (polar mp sw ra));Startpunkt des Bogens
         (setq ept (polar mp ew ra));Endpunkt des Bogens
         (setq ufak -1);Setzen eines Faktors zur Vorzeichenumrechnung fr Ausbuchtungswert
      )
   )
   (arxload "geomcal" "\"geomcal\" geladen");Laden des Geometrierechners
   (kal "sempt=(plt(spt,ept,0.5))");Mittelpunktkoordinaten zuwischen Start- und Endpunkt
   (setq D (distance spt ept));Distanz zwischen Start- und Endpunkt (Sehnenlnge)
   (setq hlpdist (distance sempt mp));HilfsEntfernung vom errechneten Sehene mittelpunkt zum BogenZentrumspunkt
   (setq hlpwink (abs (- ew sw)));Absolutwert des Bogenffnungswinkels
   (if (> hlpwink pi);dementsprechend errechnet sich die Hhe des Kreisabschnitts
      (setq H (+ ra hlpdist));Hhe des Kreisabschnitts (Stich)
      (setq H (- ra hlpdist))
   )
   ;Das Vorzeichen des Ausbuchtungswertes ist abhngig von
   ;   - Zeichenrichtung -> ufak
   ;   - Absolutrichtung des Winkels -> (- ew sw)
   ;und berechnet sich aus der Division der Hhe durch die Lnge
   (if (< (- ew sw) 0)
      (setq abung (* 2 ufak (/ H D)))
      (setq abung (* -2 ufak (/ H D)))
   )
   (setq buli (list spt ept abung));Zusammenstellen der bergabeliste (Startpunt Endpunkt Ausbuchtung)
   buli;bergabe der Liste an aufrufende Funktion
);(abu)
;;;
;;;
;;;-SUB--SUB--SUB--SUB--SUB--SUB--SUB--SUB-
;;;
;;;Zeichnen der Polylinie, Berechnung der Flche (so man mchte Lschen der Polylinie)
;;;Aufruf aus:	hatchf
;;;Eingangswerte:	Art des Umgrenzungspfades
;;;				mfak = 1 -> Polylinie ohne Kreisbogen - oder einfache Linie
;;;				mfak = 2 -> Polylinie mit Kreisbogen
;;;				mfak = 3 -> einfache Linie mit Bogenelementen
;;;			Anzahl der Kontrollpunkte
;;;			Kontrollpunktliste
;;;			Flchenberechnung als Insel oder Umgrenzung
;;;				pm = 1 -> Insel
;;;				pm = 2 -> Umgrenzung
;;;
;;;Rckgabewerte:	Flche
;;;
;------machpolyline mltfakt anzkp liste PLUSMINUSFLCHE
(defun machpolyline (mfak kpanz ptlist pm / stz pkt pktlist1 pktlist pktwink flache_ber)
   (setq stz 0)
   (setq umgpolylay (strcat "UMG_" vgllayer))
   (entmake
     (List
       '(0 . "POLYLINE")
       (cons 8  umgpolylay)
     )
   )
   (cond
      ((= mfak 1)
         (repeat kpanz
            (setq pkt (nth stz ptlist))
            (if (= stz 0)
               (setq pktlist1 (list (cons 0 "VERTEX") pkt))
            )
            (setq pktlist (list (cons 0 "VERTEX") pkt))
            (entmake pktlist)
            (setq stz (+ stz mfak))
         )
         (entmake pktlist1)
         (entmake '((0 . "SEQEND")))
      )
      ((= mfak 3)
         (repeat (- kpanz 0)
            (setq pkt (nth stz ptlist))
            (setq pktwink (nth (+ stz 1) ptlist))
            (if (= stz 0)
               (setq pktlist1 (list (cons 0 "VERTEX") pkt (cons 40 0.0) (cons 41 0.0) pktwink))
            )
            (setq pktlist (list (cons 0 "VERTEX") pkt (cons 40 0.0) (cons 41 0.0) pktwink))
            (entmake pktlist)
            (setq stz (+ stz mfak -1))
         )
         (entmake pktlist1)
         (entmake '((0 . "SEQEND")))
      )
      ((= mfak 2)
         (repeat (- kpanz 0)
            (setq pkt (nth stz ptlist))
            (setq pktwink (nth (+ stz 1) ptlist))
            (if (= stz 0)
               (setq pktlist1 (list (cons 0 "VERTEX") pkt (cons 40 0.0) (cons 41 0.0) pktwink))
            )
            (setq pktlist (list (cons 0 "VERTEX") pkt (cons 40 0.0) (cons 41 0.0) pktwink))
            (entmake pktlist)
            (setq stz (+ stz mfak))
         )
         (entmake pktlist1)
         (entmake '((0 . "SEQEND")))
      )
   )
   (command "_area" "_E" "_L");Flchenvariable "AREA" setzen
   (setq flache_ber (getvar "area"));Flchenvariable "AREA" abfragen
   (if (= pm 1);Insel oder nicht
      (setq flache_ber (* -1.00 flache_ber))
   )
   (if (= pm 2)
      (setq flache_ber (* 1 flache_ber))
   )
   ;(command "_erase" "L" "");Polylinie kann wieder gelscht werden, dazu mu das ";" entfernt werden
   (princ "\nWie: ")
   (if (= pm 1)
      (princ "Minus")
      (princ "Plus")
   )
   (princ pmw)
   (princ "\nFlche: ")
   (princ flache_ber)
   flache_ber
);machpolyline
;;;
;;;-SUB--SUB--SUB--SUB--SUB--SUB--SUB--SUB-
;;;
;;;Auswertung auf der Zeichnung, Einfgen eines Blckes der die Flchenbezeichnung und den Flchenwert als Attribute beinhaltet
;;;
;;;Aufruf aus:	c:hatchfl
;;;
;;;Eingangswerte:	Textliste [ liste(Layer Flche Layer Flche ...) ]
;;;Rckgabewerte: ---
;;;
(defun schreibefltext (textlist / w270 ipt textz utext firma flachtext)
   (setq w270 (* 270 (/ pi 180)))
   (setq ipt (getpoint "\Legende Einfgepunkt"))
   (setq textz 0)
   (setvar "attdia" 0)
   (repeat (/ (length textlist) 2)
      (setq ipt (polar ipt w270 3.5))
      (setq utext (nth textz textlist))
      (command "_LAYER" "T" utext "EI" utext "SE" utext "")
      (setq firma (firmzuordn utext))
      (setq flachtxt (rtos (nth (+ textz 1) textlist) 2 2))
      (if (= textz 0)
         (command "_insert" "c:\\legend_1.dwg" ipt "1" "1" "0" firma flachtxt);Pfad kann gendert werden
         (command "_insert" "c:\\legend_f.dwg" ipt "1" "1" "0" firma flachtxt);Pfad kann gendert werden
      )
      (setq textz (+ textz 2))
   )
);schreibefltext
;;;
;;;
;;;-SUB--SUB--SUB--SUB--SUB--SUB--SUB--SUB-
;;;
;;;Dialogfenster gesttzte Zuordnung von Layernamen zum Legendentext
;;;
;;;Aufruf aus:	schreibefltext
;;;
;;;Eingangswerte:	Layername
;;;
;;;Rckgabewerte:	LegendenText
;;;
(defun firmzuordn (text / dcl_id fname wei)
   (setq dcl_id (load_dialog "schraff.dcl"))
   (if (not (new_dialog "schraff1" dcl_id))
   (exit))
   (set_tile "layname" text)
   (set_tile "fname" text)
   (setq fname text)
   (action_tile "fname" "(setq fname (get_tile \"fname\"))")
   (action_tile "accept" "(setq wei 1)(done_dialog)")
   (action_tile "cancel" "(setq wei 0)(done_dialog)")
   (start_dialog)
   (unload_dialog dcl_id)
   (if (= wei 0)(exit))
   fname
);firmzuordn
;;;
;;;--------------------------------------------------ENDE---------------------------------------------------
;;;
;;;
(princ "Schraffurflchenberechnung geladen. ==>Start mit: hatchfl")
(princ)
